<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>QuADTool Quickstart Guide and Reference</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link href="https://fonts.googleapis.com/css?family=Nunito+Sans:300,400,600,700,800,900" rel="stylesheet">
    <link rel="stylesheet" href="scribbler-global.css">
    <link rel="stylesheet" href="scribbler-doc.css">
    <link rel="author" href="Florian Dorfhuber florian.dorfhuber@in.tum.de">
    <style>
          img {
            display: block;
            margin-left: auto;
            margin-right: auto;
          }


    </style>
</head>
<body>
<div class="doc__bg"></div>
<nav class="header">
    <h1 class="logo">QuADTool&nbsp;<span class="logo__thin">Doc</span></h1>
    <ul class="menu">
        <div class="menu__item toggle"><span></span></div>
        <li class="menu__item"><a href="https://gitlab.com/live-lab/software/add-tool" class="link link--dark"><i
                class="fa fa-github"></i> Github</a></li>
        <!--<li class="menu__item"><a href="index.html" class="link link--dark"><i class="fa fa-home"></i> Home</a></li>-->
    </ul>
</nav>
<div class="wrapper">
    <aside class="doc__nav">
        <ul>
            <li class="js-btn selected">Quick start</li>
            <li class="js-btn">Get Started</li>
            <li class="js-btn">UI</li>
            <li class="js-btn">Files</li>
            <li class="js-btn">Operators</li>
            <li class="js-btn">Domains</li>
            <li class="js-btn">Analysis</li>
            <li class="js-btn">Keybindings</li>
            <li class="js-btn">Integration</li>
            <li class="js-btn">Security</li>
            <li class="js-btn">Accessibility</li>
            <li class="js-btn">Plugins</li>
            <li class="js-btn">Libraries</li>
        </ul>
    </aside>
    <article class="doc__content">
        <section class="js-section">
            <h2 class="section__title">Quick start</h2>
            <p>Quick instructions for the most basic functions. There is a full reference for all features below.</p>
            <h3>Installation</h3>
            <p>To run QuADTool put the .jar-File from <a href="https://gitlab.com/live-lab/software/add-tool/-/raw/main/release/latest.jar">here</a> in to the target folder.
                Then start it using your installed java version.
                Alternatively you can add it as <a href="https://plugins.jetbrains.com/plugin/21844-quadtool">plugin</a> to your IntelliJ based IDE</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
                java -jar quadtool.jar
                PATH_TO_JAVA_BIN -jar quadtool.jar
              </code>
            </pre>
            </div>
            <p>NOTE: In most OS with properly installed java-versions (at least JDK 14) a double click on the .jar-File
                starts the editor.</p>

            <h3>First start</h3>
            <img src="quadtool_initial.png" alt="Initial setup">
            <p>On first startup you can select your <b>language</b> (new languages can be added as plugins) and a
                standard <b>settings profile</b>. <br> You can also start the automatic search for analysis tools.</p>

            <img src="quadtool_tuto.png" alt="Tutorial popup">
            <p>Then a Guide will show you the most important features of the tool.</p>


            <h3>Open file</h3>
            <img src="quadtool_open.png" alt="Open button">
            <p>To open a file press the open-button in the toolbar or the key combination <b>CTRL+O</b>. Then select a
                <b>.dot</b> or <b>.xml</b> file from the standards listed below.<br>
                We provide some examples in the "examples" directory of the tool folder.<br>
                You can access them via <b>CTRL+SHIFT+O</b>. The examples are labeled with the language and their complexity.</p>


            <h3>Manipulate model</h3>
            <img src="quadtool_example.png" alt="Example model">
            <p>To move nodes/vertices you can drag them to the new position. Dragging from the label will create a new
                edge. Pressing <b>ENTER</b> will open an edit dialog.</p>

            <img src="quadtool_edit_vertex.png" alt="Dialog for editing vertices">
            <p>You can change the vertex type, name and other properties here.<br>
                To change the label or the type of vertex, you can also <b>right click</b> it and select the option in the popup Menu. </p>

            <img src="quadtool_leftToolbar.png" alt="Left toolbar">
            <p>New vertices can be created by clicking or dragging buttons in the left toolbar.</p>

            <h3>Analysis</h3>
            <img src="quadtool_run.png" alt="Run button">
            <p>An easy way to analyse your model is the run button in the toolbar. You can also look at the Panel on
                the right border of the window.</p>

            <h3>Saving/Export</h3>
            <p>You can save the model with the saving button in the toolbar or by using <b>CTRL+S</b>.
                To export a file to other formats you can use <b>CTRL+E</b> or the item in the <b>File</b>-menu.</p>
            <hr/>
        </section>

        <section class="js-section">
            <h2 class="section__title">Get Started</h2>
            <h3 >Installation</h3>
            <h4 >Java</h4>
            <p>An installation of java (JDK 14 or above) is necessary to run the tool.
                You can download it <a href="https://openjdk.org/">here</a>.
                They also provide installation instructions.</p>
            <h4>QuADTool</h4>
            <p>To run QuADTool put the .jar-File from the <a href="https://gitlab.com/live-lab/software/add-tool/-/raw/main/release/latest.jar">download</a>-page in to the target folder.
                <b>NOTE:</b> The tool and the executing user must have writing permission in this folder.</p>
            <h4>Run</h4>
            <p>Type one of the following commands in your shell. If the jdk is added to the PATH the first one
                should be sufficient.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
                java -jar quadtool.jar
                PATH_TO_JAVA_BIN -jar quadtool.jar
              </code>
            </pre>
            </div>
            <p><b>NOTE:</b> In most OS with properly installed java-versions (at least JDK 14) a double click on the
                .jar-File starts the editor.</p>

            <h4>Plugin</h4>
            <p>QuADTool has a IntelliJ plugin located at the <a href="https://plugins.jetbrains.com/plugin/21844-quadtool">marketplace</a>. It will automatically run in your IDE.</p>
            <hr/>
        </section>

        <section class="js-section">
            <h2 class="section__title">UI</h2>
            <!--<h3 class="section__title">Main window</h3>-->
            <img src="quadtool_overview.png" style="width: 60vw;" alt="Initial setup">
            <ol type="1">
                <li>Canvas: Here you edit the graph by arranging the vertices.</li>
                <li>Tutorial window: On first start the tour will help you find your way through the tool. You can restart the tour in the Help item of the menu bar (8) </li>
                <li>Top toolbar: It contains actions for opening/saving files, analyzing the model, changing the node font, cut, copy, paste and git (not displayed)</li>
                <li>Left toolbar: Edit vertices, sort the graph or add new vertices by clicking a button or dragging it to the canvas.</li>
                <li>Feedback area: Gives you feedback on your model in terms of structure and a specific output format.</li>
                <li>Analysis area: Outputs data generated by analysing the current model.</li>
                <li>Model checker area: Click the "*" button to select a model checker and run the analysis. (see analysis section)</li>
                <li>Menu Bar: Most of the toolbar actions are represented here again. Also, you can find the settings dialog in the File Menu. </li>
            </ol>
        </section>

        <section class="js-section">
            <h2 class="section__title">Files</h2>
            <p>QuADTool uses a variety of files. This section gives you an overview on them and when to use them.
                In-/Export options can be extended using the plugin system.</p>
            <table id="customers">
                <tr>
                    <th>Filetype</th>
                    <th>Extension</th>
                    <th>Import</th>
                    <th>Export</th>
                    <th>Related Tool</th>
                </tr>
                <!--&#x2713; Checkmark &#x2718;-->
                <tr>
                    <td>Dot</td>
                    <td>.dot</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://graphviz.org/">Graphviz</a></td>
                </tr>
                <tr>
                    <td>DUMP</td>
                    <td>.dump</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td>QuADTool</td>
                </tr>
                <tr>
                    <td>XML (ADTool)</td>
                    <td>.xml</td>
                    <td><b>&#x2713;</b></td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://satoss.uni.lu/members/piotr/adtool/">ADTool</a></td>
                </tr>
                <tr>
                    <td>PRISM</td>
                    <td>.prism</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://www.prismmodelchecker.org/games/">PRISM Games</a></td>
                </tr>
                <tr>
                    <td>XML (UPPAAL)</td>
                    <td>.xml/.uppaal.xml</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://uppaal.org/">UPPAAL</a></td>
                </tr>
                <tr>
                    <td>Modest</td>
                    <td>.modest</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td><a href="https://www.modestchecker.net/">Modest</a></td>
                </tr>
                <tr>
                    <td>PNG</td>
                    <td>.png</td>
                    <td>&#x2718;</td>
                    <td><b>&#x2713;</b></td>
                    <td>Any image viewer</td>
                </tr>
            </table>
            <hr/>

            <h3>Dot</h3>
            <p>The Dot-File defines nodes and their connections.
                The tool <a href="https://graphviz.org/">Graphviz</a> can use it to generate image-files.
                It is the main internal file of QuADTool, as it has almost no restrictions in the amount of data stored
                or the range of operators.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>digraph {
                1 [operator="BE",name="exploit_software",
                distribution="Attacker",probability="1.0",cost="1.0"];
                2 [operator="Not",label="Not"];
                1->2
              }
              </code>
            </pre>
            </div>
            <p>This example defines an ADD with one Basic Event (see operators section) and a Not operator attached to
                it.<br>
                <b>NOTE:</b> The tool will add a lot more data. This is the minimum to make it parsable.<br>
                <b>NOTE:</b> The tool saves your progress  in this format automatically during runtime in the tmp-folder.
                    You can find it in the installation folder. </p>
            <hr/>

            <h3>Dump</h3>
            <p>If you want to save your model to resume editing at a later point and the model is somehow invalid, you can save it as a dump file.
            This is a strict representation of your current state. It can be loaded via the open-file action.</p>
            <hr/>

            <h3>XML (ADTool)</h3>
            <p>The XML-format is derived from the <a href="https://satoss.uni.lu/members/piotr/adtool/">ADTool</a>
                specifications.</p>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <textarea rows="11" cols="40" style="border:none;">
<adtree>
    <node refinement="conjunctive">
        <label>And</label>
        <node refinement="disjunctive">
            <label>Steal laptop</label>
        </node>
        <node refinement="disjunctive">
            <label>Steal password</label>
        </node>
    </node>
</adtree></textarea>
            </pre>
            </div>
            <p>This example defines an ADD with two Basic Events connected by an And node.<br>
                <b>NOTE:</b> The tool will add a lot more data. This is the minimum to make it parsable. </p>
            <h4>Restrictions</h4>
            <p>The format only supports <b>one root</b> node. The allowed operators are And, Or, Not, Sand, Basic Event
                (Attacker, Defender) (see operators section).
                <br><b>NOTE:</b> Sand is only supported in versions >=2.0. If you use Sand the model must not contain
                Not and Defender nodes.</p>
            <h4>Analysis</h4>
            <p>QuADTool automatically exports data for the analysis of success probability and minimum cost (see domains
                section).
                The ADTool provides more domains that can be added in the tool. One example is the reachability of a
                goal in k time-units.
                The handbook can be downloaded <a href="https://satoss.uni.lu/members/piotr/adtool/manual.pdf">here</a>.
            </p>
            <hr/>

        <h3>PRISM</h3>
        <p>The PRISM-format can be used to analyse models with <a href="https://www.prismmodelchecker.org/games/">PRISM
            Games</a>.</p>
        <details>
            <summary>Example file</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
smg

player attacker
    [a1]
endplayer

player defender
    [a2], [default]
endplayer

module ADD
turn : [0..1] init 0;
v0 : [-1..1] init 0;
v1 : [-1..1] init 0;
v2 : [-1..1] init 0;
[default] (turn=1 & v0=0 & v1=1 & v2=0) -> 1.0:(turn'=0) & (v1'=1);
[a2] (turn=1 & v0=0 & v1=1 & v2=0) -> 1.0:(turn'=0) & (v2'=1) & (v1'=1) & (v0'=1);
[a1] (turn=0 & v0=0 & v1=0 & v2=0) -> 1.0:(turn'=1) & (v1'=1);
endmodule

label "success" = v0=1;
label "fail" = v0=-1;

rewards "costAttacker"
[a1]true : 1/1;
endrewards
</code>
            </pre>
            </div>
            <p>This example represents an ADD with two Basic Events, one for each player, connected by an And node. </p>
        </details>
        <h4>Restrictions</h4>
        <p>The format allows all operators but Reset.
            Despite being allowed it makes sense to have at least one action per player.
            Otherwise, the analysis might be pointless.
        <h4>Analysis</h4>
        <p>The provided properties for PRISM allow to analyse the success probability for an attacker in a two player
            game.
            Thus, the results may defer from other tools, as the players alternately take terms
        <br><b>NOTE:</b> Analysing models with more than 20 nodes becomes very slow. With about 30 nodes or more it
        might never finish.</p>
        <hr/>

        <h3>XML (UPPAAL)</h3>
        <p>This XML-format can be used by the <a href="https://uppaal.org/">UPPAAL</a> model checker.
            It relies on automata for every node and messages sent to the successor nodes.
            All root nodes are connected to a winning state.</p>
        <details>
            <summary>Example file</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <textarea rows="329" cols="101" style="border:none;">
<nta>
<declaration>
int update_And0=0,state_And0=0,timestamp_And0=0;
int update_BEPlayer1=0,state_BEPlayer1=0,timestamp_BEPlayer1=0;
int update_BEPlayer2=0,state_BEPlayer2=0,timestamp_BEPlayer2=0;
int steps=1;
double costvar=0.0;
urgent broadcast chan propagate;
</declaration>

<template>
	<name>And0</name>
<declaration>void updateSuccs(){
}
void updateSelf(int stat){
state_And0=stat;
timestamp_And0=steps;
steps++;
}</declaration>
	<location id="id0" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id1" x="1200" y="210">
<name x="1200" y="210">FAILED</name>
</location>
	<location id="id2" x="1200" y="-150">
<name x="1200" y="-150">TRUE</name>
</location>
	<location id="id3" x="1200" y="0">
<name x="1200" y="0">UNDECIDED</name>
</location>
	<location id="id4" x="-100" y="0"></location>
	<init ref="id0"/>
	<transition>
		<source ref="id4"/>
		<target ref="id0"/>
		<label kind="guard" x="-100" y="30">update_And0==1</label>
		<label kind="synchronisation" x="-100" y="60">propagate!</label>
		<label kind="assignment" x="-100" y="90">update_And0=0</label>
	</transition>
	<transition>
		<source ref="id1"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1200" y="240">propagate!</label>
		<label kind="assignment" x="1200" y="270">updateSuccs()</label>
		<nail x="1200" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id2"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1400" y="-150">propagate!</label>
		<label kind="assignment" x="1400" y="-120">updateSuccs()</label>
		<nail x="1400" y="-150"/>
		<nail x="1400" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id3"/>
		<target ref="id4"/>
		<label kind="synchronisation" x="1300" y="0">propagate!</label>
		<label kind="assignment" x="1300" y="30">updateSuccs()</label>
		<nail x="1300" y="0"/>
		<nail x="1300" y="310"/>
		<nail x="-100" y="310"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id2"/>
		<label kind="synchronisation" x="180" y="-150">propagate!</label>
		<label kind="guard" x="300" y="-150">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="-150">state_And0=1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-150"/>
		<nail x="1170" y="-150"/>
		<nail x="1170" y="-150"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="210">propagate!</label>
		<label kind="guard" x="300" y="210">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="210">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="210"/>
		<nail x="1170" y="210"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="180">propagate!</label>
		<label kind="guard" x="300" y="180">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="180">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="180"/>
		<nail x="1170" y="180"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="150">propagate!</label>
		<label kind="guard" x="300" y="150">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="150">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="150"/>
		<nail x="1170" y="150"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="120">propagate!</label>
		<label kind="guard" x="300" y="120">state_BEPlayer1==-1&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="120">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="120"/>
		<nail x="1170" y="120"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id1"/>
		<label kind="synchronisation" x="180" y="90">propagate!</label>
		<label kind="guard" x="300" y="90">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==-1</label>
		<label kind="assignment" x="30" y="90">state_And0=-1</label>
		<nail x="30" y="0"/>
		<nail x="30" y="90"/>
		<nail x="1170" y="90"/>
		<nail x="1170" y="210"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="0">propagate!</label>
		<label kind="guard" x="300" y="0">state_BEPlayer1==1&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="0">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="0"/>
		<nail x="1170" y="0"/>
		<nail x="1170" y="0"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="-30">propagate!</label>
		<label kind="guard" x="300" y="-30">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==1</label>
		<label kind="assignment" x="30" y="-30">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-30"/>
		<nail x="1170" y="-30"/>
		<nail x="1170" y="0"/>
	</transition>
	<transition>
		<source ref="id0"/>
		<target ref="id3"/>
		<label kind="synchronisation" x="180" y="-60">propagate!</label>
		<label kind="guard" x="300" y="-60">state_BEPlayer1==0&amp;&amp;state_BEPlayer2==0</label>
		<label kind="assignment" x="30" y="-60">state_And0=0</label>
		<nail x="30" y="0"/>
		<nail x="30" y="-60"/>
		<nail x="1170" y="-60"/>
		<nail x="1170" y="0"/>
	</transition>
</template>
<template>
	<name>BEPlayer1</name>
<declaration>void updateSuccs(){
update_And0=1;
}
void updateSelf(int stat){
state_BEPlayer1=stat;
timestamp_BEPlayer1=steps;
steps++;
costvar=costvar+1.0;
}</declaration>
	<location id="id5" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id6" x="400" y="-100">
<name x="400" y="-100">SUCCESS</name>
</location>
	<location id="id7" x="400" y="100">
<name x="400" y="100">FAILED</name>
</location>
	<location id="id8" x="600" y="-200"></location>
	<branchpoint id="id9" x="200" y="0"></branchpoint>
	<init ref="id5"/>
	<transition>
		<source ref="id5"/>
		<target ref="id9"/>
		<label kind="synchronisation" x="30" y="0">propagate!</label>
		<label kind="assignment" x="30" y="30">state_BEPlayer1=0</label>
	</transition>
	<transition>
		<source ref="id9"/>
		<target ref="id6"/>
		<label kind="probability" x="200" y="-100">1000000</label>
		<label kind="assignment" x="200" y="-70">updateSelf(1)</label>
		<nail x="200" y="-100"/>
	</transition>
	<transition>
		<source ref="id6"/>
		<target ref="id8"/>
		<label kind="synchronisation" x="430" y="-130">propagate!</label>
		<label kind="assignment" x="430" y="-160">updateSuccs()</label>
		<nail x="600" y="-100"/>
	</transition>
	<transition>
		<source ref="id7"/>
		<target ref="id8"/>
		<label kind="synchronisation" x="430" y="70">propagate!</label>
		<label kind="assignment" x="430" y="40">updateSuccs()</label>
		<nail x="600" y="100"/>
	</transition>
	<transition>
		<source ref="id8"/>
		<target ref="id5"/>
		<label kind="guard" x="0" y="-200">update_BEPlayer1==1</label>
		<label kind="synchronisation" x="0" y="-170">propagate!</label>
		<label kind="assignment" x="0" y="-140">update_BEPlayer1=0</label>
		<nail x="0" y="-200"/>
	</transition>
</template>
<template>
	<name>BEPlayer2</name>
<declaration>void updateSuccs(){
update_And0=1;
}
void updateSelf(int stat){
state_BEPlayer2=stat;
timestamp_BEPlayer2=steps;
steps++;
costvar=costvar+1.0;
}</declaration>
	<location id="id10" x="0" y="0">
<name x="0" y="0">INIT</name>
</location>
	<location id="id11" x="400" y="-100">
<name x="400" y="-100">SUCCESS</name>
</location>
	<location id="id12" x="400" y="100">
<name x="400" y="100">FAILED</name>
</location>
	<location id="id13" x="600" y="-200"></location>
	<branchpoint id="id14" x="200" y="0"></branchpoint>
	<init ref="id10"/>
	<transition>
		<source ref="id10"/>
		<target ref="id14"/>
		<label kind="synchronisation" x="30" y="0">propagate!</label>
		<label kind="assignment" x="30" y="30">state_BEPlayer2=0</label>
	</transition>
	<transition>
		<source ref="id14"/>
		<target ref="id11"/>
		<label kind="probability" x="200" y="-100">1000000</label>
		<label kind="assignment" x="200" y="-70">updateSelf(1)</label>
		<nail x="200" y="-100"/>
	</transition>
	<transition>
		<source ref="id11"/>
		<target ref="id13"/>
		<label kind="synchronisation" x="430" y="-130">propagate!</label>
		<label kind="assignment" x="430" y="-160">updateSuccs()</label>
		<nail x="600" y="-100"/>
	</transition>
	<transition>
		<source ref="id12"/>
		<target ref="id13"/>
		<label kind="synchronisation" x="430" y="70">propagate!</label>
		<label kind="assignment" x="430" y="40">updateSuccs()</label>
		<nail x="600" y="100"/>
	</transition>
	<transition>
		<source ref="id13"/>
		<target ref="id10"/>
		<label kind="guard" x="0" y="-200">update_BEPlayer2==1</label>
		<label kind="synchronisation" x="0" y="-170">propagate!</label>
		<label kind="assignment" x="0" y="-140">update_BEPlayer2=0</label>
		<nail x="0" y="-200"/>
	</transition>
</template>
<template>
	<name>Won</name>
	<location id="id15" x="0" y="0"></location>
	<location id="id16" x="-400" y="150">
<name x="-400" y="150">Success</name>
</location>
	<location id="id17" x="400" y="150">
<name x="400" y="150">Failed</name>
</location>
	<init ref="id15"/>
	<transition>
		<source ref="id15"/>
		<target ref="id16"/>
		<label kind="synchronisation" x="-220" y="30">propagate!</label>
		<label kind="guard" x="-370" y="30">state_And0==1</label>
		<nail x="0" y="30"/>
		<nail x="-400" y="30"/>
	</transition>
	<transition>
		<source ref="id15"/>
		<target ref="id17"/>
		<label kind="synchronisation" x="180" y="30">propagate!</label>
		<label kind="guard" x="30" y="30">state_And0==-1</label>
		<nail x="0" y="30"/>
		<nail x="400" y="30"/>
	</transition>
</template>
<system>
system And0,BEPlayer1,BEPlayer2,Won;
</system>
<queries>
		<query>
			<formula>Pr[#&lt;=1000000](&lt;&gt; Won.Success)
			</formula>
			<comment>
			</comment>
		</query>
		<query>
			<formula>Pr[#&lt;=1000000](&lt;&gt; Won.Failed)
			</formula>
			<comment>
			</comment>
		</query>
</queries>
</nta>
</textarea>
            </pre>

                <p>This example defines an ADD with two Basic Events connected by an And node.</p>
            </div>
        </details>

        <h4>Restrictions</h4>
        <p>The format supports no timed analysis. Thus, models using timed Basic Events might not evaluate properly.
            There are no other restrictions in the choice of operators. The export was tested on models with over 100
            nodes.</p>
        <h4>Analysis</h4>
        <p>QuADTool automatically exports data for the analysis of success probability.
            More complex analysis can be added manually to the files.</p>
        <hr/>


        <h3>Modest</h3>
        <p>The Modest-format can be used by the <a href="https://www.modestchecker.net/">Modest</a> model checker.
            Modest can also transform the file to the jani format.</p>

        <details>
            <summary>Example file</summary>
            <div class="code__block code__block--notabs">
            <pre class="code code--block">
              <code>
bool wantToSchedule=false;
real epsilon = 0.00001;
action propagate;
action resetsDone;
action triggersDone;

real globalCosts= 0;

int state=0;
property P_won = Pmin(<> (state==1));
property P_los = Pmin(<> (state==-1));
int attack_state=0;
int def_state=0;
property Att_won = Pmin(<> (attack_state==1 && def_state!=1 ));
property Def_won = Pmin(<> (def_state==1 && attack_state!=1));
property Both_won = Pmin(<> (def_state==1 && attack_state==1));
property None_won = Pmin(<> (def_state!=1 && attack_state!=1));
action ttAnd0;
action ffAnd0;
action uuAnd0;

action ttBETime1;
action ffBETime1;
action uuBETime1;
action scheduleBETime1;

action ttBETime2;
action ffBETime2;
action uuBETime2;
action scheduleBETime2;

process Controller(){
bool canPropagate = false;
bool doBreak = false;

urgent(true) propagate;
do{
  ::urgent(true) triggersDone {= doBreak=false =};
    urgent(true) resetsDone;
     when(wantToSchedule) urgent(wantToSchedule) propagate {= wantToSchedule=false =}
  }
    }
process And0(){
do{

  ::alt{
    ::ttBETime1;
      alt{
        ::ttBETime2; urgent(true) ttAnd0{= state = 1, attack_state = 1 =}
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) uuAnd0
      }
    ::ffBETime1;
      alt{
        ::ttBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
      }
    ::uuBETime1;
      alt{
        ::ttBETime2; urgent(true) uuAnd0
        ::ffBETime2; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime2; urgent(true) uuAnd0
      }
    ::ttBETime2;
      alt{
        ::ttBETime1; urgent(true) ttAnd0{= state = 1, attack_state = 1 =}
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) uuAnd0
      }
    ::ffBETime2;
      alt{
        ::ttBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
      }
    ::uuBETime2;
      alt{
        ::ttBETime1; urgent(true) uuAnd0
        ::ffBETime1; urgent(true) ffAnd0{= state = -1, attack_state = -1 =}
        ::uuBETime1; urgent(true) uuAnd0
      }
  }
}
}


process BETime1(){
clock c;
real tp;
urgent(true) tau {= tp=, c=0 =};
do{
  alt{
    ::when(c<=tp+epsilon) propagate; urgent(true) uuBETime1
    ::when(c>=tp) urgent(c>=tp) tau {= wantToSchedule=true, globalCosts+=1.0 =};
      palt{
        :1.0:do{urgent(true) propagate;
          urgent(true) ttBETime1}
        :1-1.0:do{urgent(true) propagate;
          urgent(true) ffBETime1}
      }
}
}
}


process BETime2(){
clock c;
real tp;
urgent(true) tau {= tp=, c=0 =};
do{
  alt{
    ::when(c<=tp+epsilon) propagate; urgent(true) uuBETime2
    ::when(c>=tp) urgent(c>=tp) tau {= wantToSchedule=true, globalCosts+=1.0 =};
      palt{
        :1.0:do{urgent(true) propagate;
          urgent(true) ttBETime2}
        :1-1.0:do{urgent(true) propagate;
          urgent(true) ffBETime2}
      }
}
}
}

par{::Controller()::And0()::BETime1()::BETime2()}
</code>
            </pre>
            </div>
            <p>This example represents an ADD with two Basic Events, triggered by time, connected by an And node. </p>
        </details>
        <h4>Restrictions</h4>
        <p>The format is designed for time analysis. Therefore, we recommend only using timed Basic Events.</p>
        <h4>Analysis</h4>
        <p>QuADTool automatically exports data for the analysis of success probability. More complex analysis can be
            added manually to the files.</p>
        <hr/>
        </section>


        <section class="js-section">
            <h2 class="section__title">Operators</h2>
            <p>This section lists all available operators with their intuition and examples. Every node can be in three states. It can be true, false or undecided.</p>

            <h3>Basic Event</h3>
            <p>Basic Events can be of three types. They can either be owned by a player, <b>attacker</b> or <b>defender</b>, or by <b>time</b>.<br>
            Defender actions do not have to improve security.
                If the defender uses a weak password policy it is not done by an attacker but increases the likelihood of a successful attack.<br>
            Timed basic events can happen without active human interaction. One example is corrosion of a mechanical part over time.</p>
            <h3>And</h3>
            <p>The And operator requires all nodes connected to it to succeed. For example one has to get access to a target computer and get the password.</p>
            <h3>Sequential-And (SAnd)</h3>
            <p>The SAnd operator requires all nodes connected to it to succeed in order. For example one has to enter the gate to the property before entering the building door.</p>

            <h3>Or</h3>
            <p>The Or operator requires any node connected to it to succeed. For example one can either use the front or the back door of a building to enter it.</p>
            <h3>Sequential-Or (SOr)</h3>
            <p>The SOr operator requires any node connected to it to succeed. But the failed ones have to fail in order.
                For example one has to first fail entering the pin of a mobile phone trice, before entering a PUK.</p>


            <h3>Not</h3>
            <p>The Not operator is a Unary-operator. It allows only one predecessor.
                The operator is true if the predecessor is false. It is undecided if the predecessor is undecided.
                For example an attacker needs the target system to not be shut down.</p>
            <h3>Not attempted (Nat/Ivr)</h3>
            <p>The Nat operator is a Unary-operator. It allows only one predecessor.
                The operator is true if the predecessor is undecided. If the valuation of the predecessor changes it becomes false.
                For example an attack requires that the defender has not tried to unplug the device from the LAN-Network.</p>
            <h3>Not true</h3>
            <p>The Not true operator is a combination of Not and Nat.
                The operator is true if the predecessor is undecided or false.
                If the valuation of the predecessor changes to true it the Not-true-operator becomes false.
                For example an attacker wants the security system to either not be started or to have failed the start.</p>


            <h3>Cost</h3>
            <p>The Cost operator works as a gate for costs in the subtree.
                The operator is true if all conditions are met and false if at least one is not.
                For example if a company has limited funds to invest in their security infrastructure.</p>
            <h3>Trigger</h3>
            <p>Trigger operator can be connected to Basic Events.
                If it evaluates to true it allows the players/time to attempt the connected events.
                For example a car standing in public triggers the possibility to steal it without entering a garage.</p>
            <h3>Reset</h3>
            <p>The Reset operator sets the connected Basic Events to undecided.
            This will also reevaluate their successor nodes.
            For example restarting a system will disconnect the attacker and require him to establish it again.</p>
        </section>

        <section class="js-section">
            <h2 class="section__title">Domains</h2>
            <p>This section lists all available domains for analysis. They are based on the three supported data types.
                New analysis can be added as a plugin.</p>

            <h3>Available data</h3>
            <img src="quadtool_edit_vertex_pac.png" alt="Edit dialog">
            <p>The QuADTool can store data for every basic event.
                This includes a success probability, the cost of attempting it, the delay caused by attempting the event.
            </p>
            <img src="quadtool_domain_edit.png" alt="Edit domain">
            <p>
                You can edit the content in the edit dialog. Also, the analysis panel on the right side allows editing all Basic-Event data at once.
            </p>

            <h3>Best success probability</h3>
            <p>This domain is the highest success probability. So, you can analyse how likely an optimal attack succeeds.</p>
            <h3>Minimum cost</h3>
            <p>This domain computes the lowest cost an attacker would have to spend for a successful attack.</p>
            <h3>Minimum delay</h3>
            <p>This domain computes the lowest delay an attacker would have to spend for a successful attack.
                Thus, meaning how fast an attack could be between start and success.</p>
            <h3>Probably-Approximately-Correct(PAC)</h3>
            <p>
            All values can be stored as probably-approximately-correct(PAC)-values. This can be seen as a confidence interval.
            The probability &delta; is 1-&alpha;. &epsilon; is the distance from the mean for the bound.
            PAC-data can for instance be obtained by the ARIMA, Gaussian analysis from csv-Files integrated in the edit-dialog (marked by the orange circle).<br>
            <b>NOTE:</b> PAC is enabled by default only in expert settings. It can be turned on in the settings.</p>

        </section>
        <section class="js-section">
            <h2 class="section__title">Analysis</h2>

            <h3>Internal</h3>
            <p>The tool automatically analyses the domains listed above in the analysis panel on the right side of the screen.</p>
            <img src="quadtool_analysis.png" alt="Analysis panel">
            <p><b>NOTE:</b> In the beginner profile only probability is displayed. You can enable the others in the settings.</p>

            <h3>External</h3>
            <p>External analysis can be done using the run button or the model checker panel in the lower right corner.</p>
            <img src="quadtool_checkers.png" alt="Checker settings">
            <p>Clicking the star button in the checker panel will open the settings dialog. Here you can review the general settings for model checking and choose a tool.
                To use another tool you have to choose the executable file from your hard-drive. For UPPAAL and ADTool special versions are needed as others do not have a cli.
            </p>
            <ul>
                <li>ADTool (Version >=2.0)</li>
                <li>UPPAAL verifyta</li>
            </ul>
            <p>
            The parameters are prepared but can be changed at will. The placeholders have the following meaning.
            </p>
            <ul>
                <li>[tool] &#8594; Path to the tool</li>
                <li>[input] &#8594; the temporary file which is exported by QuADTool</li>
                <li>[output] &#8594; the temporary file which generated by the model checker output.</li>
            </ul>
            <p>
            After clicking "save" the model will be analysed and the output will be presented in a new tab.
            </p>

        </section>

        <section class="js-section">
            <h2 class="section__title">Keybindings</h2>
            <table>
                <tr>
                    <th>Key</th>
                    <th>Action</th>
                </tr>
                <tr>
                    <td>CTRL+N</td>
                    <td>Open new empty file</td>
                </tr>
                <tr>
                    <td>CTRL+S</td>
                    <td>Save current file</td>
                </tr>
                <tr>
                    <td>CTRL+SHIFT+S</td>
                    <td>Save current file after choosing a target file.</td>
                </tr>
                <tr>
                    <td>CTRL+O</td>
                    <td>Open new file</td>
                </tr>
                <tr>
                    <td>CTRL+SHIFT+O</td>
                    <td>Open example file</td>
                </tr>
                <tr>
                    <td>CTRL+E</td>
                    <td>Export file</td>
                </tr>
                <tr>
                    <td>CTRL+R</td>
                    <td>Run file</td>
                </tr>
                <tr>
                    <td>CTRL+Z</td>
                    <td>Undo last action</td>
                </tr>
                <tr>
                    <td>CTRL+Y</td>
                    <td>Redo an undone action</td>
                </tr>
                <tr>
                    <td>CTRL+C</td>
                    <td>Copy selection</td>
                </tr>
                <tr>
                    <td>CTRL+X</td>
                    <td>Cut selection</td>
                </tr>
                <tr>
                    <td>CTRL+V</td>
                    <td>Paste selection</td>
                </tr>
                <tr>
                    <td>CTRL+SHIFT+O</td>
                    <td>Sort model</td>
                </tr>
                <tr>
                    <td>F1</td>
                    <td>Open help window</td>
                </tr>
                <tr>
                    <td>Enter</td>
                    <td>Edit selected vertex</td>
                </tr>
            </table>
        </section>


        <section class="js-section">
            <h2 class="section__title">Integration</h2>

            <h3>GIT</h3>
            <ul>
                <li>QuADTool detects if the current file is inside a GIT-Repository.</li>
                <li>It will ask you if you want to add the file to it at saving (If it was not already added).</li>
                <li>You can also pull, commit and push from the interface.</li>
                <li>If necessary the tool will ask for your credentials on push.
                    Credentials will only be permanently saved if added in the settings dialog.</li>
                <li>Requirements a model has to fulfill on commit can be written to the ".quadtool" file in the root directory of the repository.
                    <br>You can also edit the requirements over an item in the Menu Bar</li>
            </ul>

            <p>  <b>NOTE:</b> GIT-Options will only be visible if a repository is detected.</p>


            <h3>ATBest</h3>
            <p>QuADTool was developed in a research environment. We would be happy if you can support our cause by sending in your models.
            As we only want to know the structure, your model will be striped from all names in nodes. This ensures confidentiality of the security system.
            You can upload the model by clicking the cloud button in the top toolbar. The first time you will be asked to enter some information about you.
            After submission, you will receive a token to your email address. You can use it to have a look at all other models in the database.</p>


            <h3>IntelliJ</h3>
            <p>We built a plugin for the IntelliJ platform which allows you to generate and edit ADD files in your project.
                It adds an option in you "Tools" menu and your toolbar.<br>
                You can also edit xml- or dot-Files in your IDE and visualize them in QuADTool.</p>
        </section>

        <section class="js-section">
            <h2 class="section__title">Security</h2>
            <p>QuADTool supports both symmetric (AES) and asymmetric (RSA) encryption.
                You can store a link to a private key and a public key in the settings.
                Encrypted private keys are supported. You will be asked for the passphrase everytime the key is needed.
                Symmetric encryption is done via a password you enter on save.
                You can select the encryption/decryption method in the file-chooser dialog.</p>
        </section>

        <section class="js-section">
            <h2 class="section__title">Accessibility</h2>
            <p>We hope QuADTool allows usage for everyone.
                We tested the color composition with Color Oracle for Windows.
                We tried the usage with the screen-reader NVDA.
                If you experience any issue with these features, feel free to contact us.</p>
        </section>
            <section class="js-section">
                <h2 class="section__title">Plugins</h2>
                <p>You can expand the functionality of QuADTool by writing plugins.
                    Therefore, implement the relevant interface and put the jar into a folder named plugins in the tool directory.
                    For new languages put the properties file in the same folder. Name it in the standard convention. E.g. "ui_strings_de.properties" for german.</p>
                    <table>
                    <tr>
                        <th>Function</th>
                        <th>Interface</th>
                    </tr>
                    <tr>
                        <td>Import</td>
                        <td>addtool.io.ADDImport.java</td>
                    </tr>
                    <tr>
                        <td>Export</td>
                        <td>addtool.io.ADDExport.java</td>
                    </tr>
                    <tr>
                        <td>Analysis in analysis tab</td>
                        <td>addtool.analysisonadd.PrintableVisitor.java</td>
                    </tr>
                    <tr>
                        <td>Model feedback</td>
                        <td>addtool.feedback.FeedbackGenerator.java</td>
                    </tr>
                    <tr>
                        <td>Modelchecker connection</td>
                        <td>addtool.nui.checking.CheckerAdapter.java</td>
                    </tr>
                </table>
                <p>To add own preferences use the addtool.helpers.preferences.PreferenceManager functionality.</p>
            </section>

        <section class="js-section">
            <h2 class="section__title">Libraries</h2>
            <p>QuADTool is packed with all necessary dependencies. You can find a full list in the license.txt in the git repository.</p>
        </section>
    </article>
</div>

<footer class="footer">Scribbler is a free HTML template created exclusively for <a href="https://tympanus.net/codrops/"
                                                                                    target="_blank"
                                                                                    class="link link--light">Codrops</a>.
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad();</script>
<script src="scribbler.js"></script>
</body>
</html>